/*
  Name: DL programowanie zadanie 15 z rozdziau 16 ksiki Thinking in C++
  Author: Piotr Leo
  Date: 27-06-06 19:28
  Description: Przekszta funkcj fibonacci() w szablon funkcji o parametrze okrelajcym
typ zwracanej przez funkcj wartoci (zamiast wartoci typu int bdzie ona
moga zwraca wartoci typw long, float itp.).
*/
//: C16:fibonacci.cpp {O}
// From Thinking in C++, 2nd Edition
// Available at http://www.BruceEckel.com
// (c) Bruce Eckel 2000
// Copyright notice in Copyright.txt


#include "require.h"
#include <iostream>

using namespace std;

template<class T>
T fibonacci(int n) 
{
  const int sz = 100;
  require(n < sz);
  static T f[sz]; // Initialized to zero
  f[0] = f[1] = 1;
  // Scan for unfilled array elements:
  int i;
  for(i = 0; i < sz; i++)
    if(f[i] == 0) break;
  while(i <= n) {
    f[i] = f[i-1] + f[i-2];
    i++;
  }
  return f[n];
  //mozna bylo takze zrobic to tak: return (T) f[n], zostalyby przeprowadzone standardowe konwersje typow i w resultacie funkcja zwrocilaby potrzebny nam typ T
} ///:~

int main()
{
    cout<<fibonacci<float>(10)<<endl;
    int a=fibonacci<int>(3);
    system("pause");
    return 0;
}
